{$M 2048,0,655360}
{$S-,R-,Q-,I-,N-,E-,G+}
uses
   BSound, Objects, DOS, Memory;

const
   VStr =          '2.2';

var
   FS              :TDosStream;
   MS              :PStream;
   i               :Integer;
   d               :String[23];
   k               :Word;

   DriveNum        :Byte;
   SmartDrvStatus  :Byte;

label
   StatusMode;

procedure ShowStatus;
var
   S               :String[79];
   V               :String[5];
   Pos             :LongInt;

procedure AddTime(Size                 :LongInt;
                  MinD                 :Integer);
var
   Time            :record
      Min, Sec     :Byte;
   end;
begin
   asm
      mov  ax,word ptr Size
      mov  dx,word ptr Size+2
      div  TimerRate
      mov  dl,60
      div  dl
      mov  word ptr Time,ax
   end;

   Str(Time.Min:MinD, V);
   S:=S+V+':';
   Str(Time.Sec:2, V); if V[1]=' ' then V[1]:='0';
   S:=S+V;
end;

begin
   Pos:=SoundPos-SoundRead+SoundBufPos;

   S:='Played ';
   AddTime(Pos, 2);
   S:=S+'/';
   AddTime(SoundSize, 1);
   Str(Pos*100 div (SoundSize+1):2, V);
   S:=S+' ('+V+'%)    ';
   Str(TimerRate div 1000:1, V);
   S:=S+V+'.';
   Str(TimerRate div 100 mod 10:1, V);
   S:=S+V+' kHz    Volume ';
   Str(SoundVolume*100 shr 6:4, V);
   S:=S+V+'% ';

   asm
      mov  ah,3
      xor  bx,bx
      int  10h
      dec  dh
      push 0
      pop  es
      mov  al,byte ptr es:[44Ah]
      mul  dh
      add  ax,ax
      mov  dx,0B800h
      cmp  byte ptr es:[449h],7
      jne  @@Color
      mov  dh,0B0h
@@Color:
      mov  es,dx
      mov  di,ax

      xor  si,si
      xor  cx,cx
      mov  cl,byte ptr S+si
      mov  ah,0Fh
      cld
@@Loop:
      inc  si
      mov  al,byte ptr S+si
      stosw
      loop @@Loop
   end;
end;

procedure GetParam(Index               :Integer);
begin
   d:=ParamStr(Index);
   for i:=1 to Byte(d[0]) do d[i]:=UpCase(d[i]);
end;

begin
   WriteLn(#13#10'Windows Sound File (.WAV) Player  Version '+VStr+#13#10+
      'Copyright (c) 1994,95 by Solar Designer \ TorNad0'#13#10);

   if ParamCount<1 then
   begin
      WriteLn(
         'Usage: PLAYWAVE.EXE filename.wav [Device] [NoRepeat]'#13#10+
         'Device can be Speaker, Covox1, Covox2, SoundBlaster');
      Halt;
   end;

   SoundRepeat:=True;

   if ParamCount>1 then
   begin
      GetParam(2);
      if Pos('SPEAKER', d)<>0 then SoundDevice:=sdPCSpeaker else
      if Pos('COVOX1', d)<>0 then SoundDevice:=sdCovox1 else
      if Pos('COVOX2', d)<>0 then SoundDevice:=sdCovox2 else
      if Pos('BLASTER', d)<>0 then SoundDevice:=sdSoundBlaster else
      if Pos('NOREPEAT', d)<>0 then SoundRepeat:=False else
      begin
         WriteLn('Invalid sound device'); Halt;
      end;

      GetParam(3);
      if d<>'' then
      if Pos('NOREPEAT', d)<>0 then SoundRepeat:=False else
      begin
         WriteLn('Invalid parameter'); Halt;
      end;
   end;

   InitMemory;

   FS.Init(ParamStr(1), stOpenRead);

   if FS.Status=stOk then
   begin
      MS:=New(PEmsStream, Init(FS.GetSize, FS.GetSize));
      if (MS=nil) or (MS^.Status<>stOk) then
      begin
         WriteLn('Not enough EMS memory available. Using conventional memory...'#13#10);
         MS:=New(PMemoryStream, Init(FS.GetSize, 64));
      end else SoundBufSize:=16384;

      MS^.CopyFrom(FS, FS.GetSize);

      MS^.Seek(0); FS.Seek(0);
   end else MS:=nil;

   if FS.Status<>stOk then
   begin
      FS.Done;
      if MS<>nil then MS^.Done;
      WriteLn('Error reading sound file'); Halt;
   end;
   if MS^.Status<>stOk then
   begin
      Dispose(MS, Done); MS:=@FS;
      WriteLn('Out of memory (both conventional and EMS). Using disk...'#13#10);

      d:=ParamStr(1);
      if d[2]=':' then DriveNum:=Byte(UpCase(d[1]))-(Byte('A')+1) else DriveNum:=0;
      asm
         mov  ah,32h
         mov  dl,DriveNum
         push ds
         int  21h
         mov  ax,512
         mov  cl,ds:[bx+5]
         shl  ax,cl
         mov  SoundBufSize,ax
         pop  ds

         mov  al,DriveNum
         dec  al
         jns  @@NotDefault
         mov  ah,19h
         int  21h
@@NotDefault:
         mov  DriveNum,al
         cbw

         push bp
         mov  bp,ax
         mov  ax,4A10h
         mov  bx,3
         xor  dx,dx
         push ax
         int  2Fh
         cmp  ax,0BABEh
         pop  ax
         jne  @@NoSmartDrv
         mov  SmartDrvStatus,dl
         mov  dl,2
         int  2Fh
@@NoSmartDrv:
         pop  bp
      end;
   end;

   if InitSound(MS)<>bsOk then
   begin
      MS^.Done;
      WriteLn('Invalid sound file'); Halt;
   end;

   StartSound;

StatusMode:
   WriteLn(
      'Enter'#9'DOS shell'#13#10+
      'Esc'#9'Stop playing'#13#10+
      '+/-'#9'Increase/decrease volume'#13#10+
      #13#10);
   repeat
      ShowStatus;

      asm
         mov  ah,1
         int  16h
         mov  ax,0
         jz   @@NoKey
         int  16h
@@NoKey:
         mov  k,ax
      end;
      case Chr(Lo(k)) of
         '+': if SoundVolume<8*64 then SoundVolume:=SoundVolume shl 1;
         '-': if SoundVolume>1    then SoundVolume:=SoundVolume shr 1;
      end;
   until (Lo(k)=27) or (Lo(k)=13) or (not PlayingSound);

   if Lo(k)=13 then
   begin
      SoundReset:=True;

      WriteLn(#13#10'Type EXIT to return ...');

      DoneDosMem;
      ExecSound(GetEnv('COMSPEC'), '');
      InitDosMem;

      WriteLn; goto StatusMode;
   end;

   StopSound;

   if (MS=@FS) and (SmartDrvStatus>$7F) then
   asm
      mov  al,DriveNum
      cbw
      push bp
      mov  bp,ax
      mov  ax,4A10h
      mov  bx,3
      mov  dl,1
      int  2Fh
      pop  bp
   end;

   MS^.Done;

   DoneMemory;
end.

